;
; Messes up character generator and prints out "linux inside" logo.
;
; Was tested by NASM - the Netwide Assembler (http://www.cryogen.com/Nasm).
;
; To create EXE executable for DOS (requires exebin.mac macros, included with
; nasm source) run:
;   nasm -fbin linside.asm -o linside.exe
;
%include "exebin.mac"
        EXE_begin


section .data

LinsideData:
%include "linside.inc"

section .bss

LINSIDE_WIDTH       equ     176/8
LINSIDE_HEIGHT      equ     154/14
LINSIDE_LEN         equ     LINSIDE_HEIGHT * LINSIDE_WIDTH
SCR_WIDTH           equ     80

section .text

    global _start

_start:
        mov     ax, ds
        mov     es, ax

        ;; Load character generator font table with our font
        mov     ah, 0x11
        mov     al, 0
        mov     dx, 0           ; first changed char
        mov     cx, LINSIDE_LEN     ; number of chars
        mov     bh, 14          ; bytes per char (BH) and page (BL)
        mov     bl, 0
        mov     bp, LinsideData     ; offset of array
        int     0x10

        ;; Print out the picture
        mov     ax, 0xb800
        mov     es, ax
        xor     di, di          ; start in upper left corner
        mov     ax, 0x0f00      ; white characters on black background
        mov     edx, LINSIDE_HEIGHT
        cld                     ; string commands increment pointer

loop_line:
        mov     ecx, LINSIDE_WIDTH
loop_char:
        stosw
        inc     al
        loop    loop_char
        ;; Go to new line and loop
        add     di, (SCR_WIDTH - LINSIDE_WIDTH) * 2
        dec     edx
        jnz     loop_line

        ;; Wait for a keystroke
wait_key:
        mov     ah, 1
        int     0x16
        jz      wait_key

        ;; Reload character generator with standard font
        mov     eax, 0x1101     ; load standard font
        xor     edx, edx        ; first changed char
        mov     ebx, 0x0e00     ; page (BL) and bytes per char (BH)
        int     0x10

BailOut:
        ;; Exit
        mov     ebx,0           ; exit code
        mov     ah,0x0
        int     0x21


        EXE_end

;
; Local variables:
; compile-command: "nasm -fbin linside.asm -o linside.exe"
; End:
;
