;
; Messes up character generator and prints out an image of tux.
;
; Was tested by NASM - the Netwide Assembler (http://www.cryogen.com/Nasm).
;
; To create EXE executable for DOS (requires exebin.mac macros, included with
; nasm source) run:
;   nasm -fbin tux.asm -o tux.exe
;
%include "exebin.mac"
        EXE_begin


section .data

TuxData:
%include "tux.inc"

section .bss

TUX_WIDTH       equ     152/8
TUX_HEIGHT      equ     182/14
TUX_LEN         equ     TUX_HEIGHT * TUX_WIDTH
SCR_WIDTH       equ     80

section .text

    global _start

_start:
        mov     ax, ds
        mov     es, ax

        ;; Load character generator font table with our font
        mov     ah, 0x11
        mov     al, 0
        mov     dx, 0           ; first changed char
        mov     cx, TUX_LEN     ; number of chars
        mov     bh, 0x0e        ; bytes per char (BH) and page (BL)
        mov     bl, 0
        mov     bp, TuxData     ; offset of array
        int     0x10

        ;; Print out the picture
        mov     ax, 0xb800
        mov     es, ax
        xor     di, di          ; start in upper left corner
        mov     ax, 0x0f00      ; white characters on black background
        mov     edx, TUX_HEIGHT
        cld                     ; string commands increment pointer

loop_line:
        mov     ecx, TUX_WIDTH
loop_char:
        stosw
        inc     al
        loop    loop_char
        ;; Go to new line and loop
        add     di, (SCR_WIDTH - TUX_WIDTH) * 2
        dec     edx
        jnz     loop_line

        ;; Wait for a keystroke
wait_key:
        mov     ah, 1
        int     0x16
        jz      wait_key

        ;; Reload character generator with standard font
        mov     eax, 0x1101     ; load standard font
        xor     edx, edx        ; first changed char
        mov     ebx, 0x0e00     ; page (BL) and bytes per char (BH)
        int     0x10

BailOut:
        ;; Exit
        mov     ebx, 0        ; exit code
        mov     ah, 0
        int     0x21


        EXE_end

;
; Local variables:
; compile-command: "nasm -fbin tux.asm -o tux.exe"
; End:
;
